import { buildUUID } from '../../../../utils/uuid';
//import { ApiAction, ApiActionPage } from '../../model/baseModel';
import { genAction, Api } from '../../system';
import { useUserStore } from '/@/store/modules/user';
import { defHttp } from '/@/utils/http/axios';
import { isNullOrEmpty } from '/@/utils/is';
import { formatToDateTime } from '/@/utils/dateUtil';
/*
 * 获取料站工单表信息
 */

export const getSmttableListByPage = async (params: any) => {
  let order = '';
  if (params.order != undefined) {
    order = params.order == 'descend' ? params.field + ' desc' : params.field;
  }
  let sqlcmd = '1=1';
  if (params?.LINE_CODE != undefined && params?.LINE_CODE != '') {
    sqlcmd += " And LINE_CODE like '%" + params?.LINE_CODE + "%'";
  }
  if (params?.SMT_CODE != undefined && params?.SMT_CODE != '') {
    sqlcmd += " And SMT_CODE like '%" + params?.SMT_CODE + "%'";
  }
  if (params?.PCB_SURFACE != undefined && params?.PCB_SURFACE != '') {
    sqlcmd += " And PCB_SURFACE like '%" + params?.PCB_SURFACE + "%'";
  }

  const option = {
    UserId: useUserStore().getUserInfo.userId as string,
    ByOrg: true,
    OrgCode: useUserStore().getUserInfo.orgCode as string,
  };
  if (!isNullOrEmpty(params.page)) {
    const usParams = genAction('SMT_WO_TABLE', {
      QueryAble_T: '',
      where: sqlcmd,
      order: order,
      page: {
        pageAble_T: 'string',
        draw: 1,
        pageIndex: params.page,
        pageSize: params.pageSize,
      },
    });
    return getSmttableListByPageAsync(usParams);
  } else {
    const usParams = genAction('SMT_WO_TABLE', {
      QueryAble_T: '',
      where: sqlcmd,
    });
    return getSmttableListByPageAsync(usParams);
  }
  // const rParams = genActionPage('BIZ_ERP_PROD_IN', sqlcmd, params.page, params.pageSize,option);
  // return getFinishedwarehouseListByPageAsync(rParams);
};
async function getSmttableListByPageAsync(params: any) {
  const data = await defHttp.post(
    { url: Api.QueryUrl, params },
    {
      isTransformResponse: false,
    },
  );
  let model = {};
  if (isNullOrEmpty(data.Data.page)) {
    model = {
      items: data.Data.Items,
    };
  } else {
    model = {
      items: data.Data.page.data,
      total: data.Data.page.totals,
    };
  }
  return model;
}
//新增工具信息
export const SaveSmttable = async (params: Recordable, isUpdate: boolean, isbaofei: boolean) => {
  const Toolitem: any = {
    ID: params.ID,
    CREATE_TIME: params?.CREATE_TIME,
    CREATE_USER: params?.CREATE_USER,
    UPDATE_TIME: params?.UPDATE_TIME,
    UPDATE_USER: params?.UPDATE_USER,
    GHOST_ROW: params?.GHOST_ROW,
    AUTH_ORG: params?.AUTH_ORG,
    AUTH_PROD: params?.AUTH_PROD,
    AUTH_WH: params?.AUTH_WH,
    WORK_ORDER: params?.WORK_ORDER,
    PROD_CODE: params?.PROD_CODE,
    ITEM_CODE: params?.ITEM_CODE,
    SUBITEM_CODE: params?.SUBITEM_CODE,
    UNIT: params?.UNIT,
    UNIT_QTY: params?.UNIT_QTY,
    LINE_CODE: params?.LINE_CODE,
    SMT_CODE: params?.SMT_CODE,
    SMT_STENCIL: params?.SMT_STENCIL,
    SLOT_NO: params?.SLOT_NO,
    LOCATION: params?.LOCATION,
    FEEDER_CODE: params?.FEEDER_CODE,
    FEEDER_TYPE: params?.FEEDER_TYPE,
    PCB_SURFACE: params?.PCB_SURFACE,
    LOAD_SEQ: params?.LOAD_SEQ,
    REMARK: params?.REMARK,
  };
  let data;

  if (isUpdate) {
    const time = new Date();
    Toolitem.UPDATE_TIME = formatToDateTime(time);
    Toolitem.UPDATE_USER = useUserStore().getUserInfo.userId as string;
    // regionitem.ORG_CODE = useUserStore().getUserInfo.orgCode as string;
    // regionitem.AUTH_ORG = useUserStore().getUserInfo.orgCode as string;
    data = await defHttp.post(
      { url: Api.UpdateEntity, params: genAction('SMT_WO_TABLE', Toolitem) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  } else {
    // const usParams = genAction(
    //   'SMT_SOLDER',
    //   "REGION_CODE='" + params.REGION_CODE + "'AND AUTH_ORG='" + regionitem.ORG_CODE + "'",
    // );
    //var check = await isExist(usParams);
    //console.log('check',check)
    //if (!check.Data) {
    Toolitem.ID = buildUUID(); //生成GUID
    Toolitem.UPDATE_TIME = formatToDateTime(new Date());
    Toolitem.CREATE_USER = useUserStore().getUserInfo.userId as string;
    Toolitem.UPDATE_USER = useUserStore().getUserInfo.userId as string;
    // regionitem.ORG_CODE = useUserStore().getUserInfo.orgCode as string;
    // regionitem.AUTH_ORG = useUserStore().getUserInfo.orgCode as string;
    data = await defHttp.post(
      { url: Api.AddEntity, params: genAction('SMT_WO_TABLE', Toolitem) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
    //} else {
    // return check.Message;
    //return '重复了';
    //}
  }
  return data;
};
//删除
export const DeleteSmttable = async (Smttable_Id: string) => {
  const usParams = genAction('SMT_WO_TABLE', `ID='${Smttable_Id}'`);
  return await defHttp.post(
    { url: Api.DeleteWhere, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
    },
  );
};
//下拉列表
// STATUSs 单据状态
export const optionsListApi = async (params: Recordable) => {
  const usParams = genAction('MES_LINE', {
    QueryAble_T: '',
  });
  const data = await defHttp.post(
    { url: Api.QueryUrl, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      // apiUrl: globSetting.taskApiUrl
    },
  );
  return data.Data.Items;
};
//类型
export const ExportTable = async (params: Recordable) => {
  const usParams = genAction('SMT_WO_TABLE', params[0].dataSource.toString());
  const data = await defHttp.post(
    { url: Api.ValidateTableImport, params: params[0].dataSource },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      // apiUrl: globSetting.taskApiUrl
    },
  );
  return data;
};
export const SaveExportTable = async (params: Recordable) => {
  const usParams = genAction('SMT_WO_TABLE', params[0].dataSource.toString());
  const data = await defHttp.post(
    { url: Api.SaveValidateTableImport, params: params[0].dataSource },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
      // apiUrl: globSetting.taskApiUrl
    },
  );
  return data;
};
